#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

bool bp3(int m)
{
	int c = 0;
	while(m) {
		if( m&1 ) ++c;
		m = m>>1;
	}
	return c==3;
}

bool isset( int n[], char c[], int m )
{
	int nn[3];
	int cc[3];
	int i=0, j=0;
	for(; j<3; ++i)
		if( m & (1<<i) )
		{
			nn[j] = n[i];
			cc[j] = c[i];
			++j;
		}
	if( cc[0]==cc[1] && cc[1]==cc[2] )
	{
		sort(nn+0, nn+3);
		return nn[0]+1==nn[1] && nn[1]+1==nn[2]   ||   nn[0]==nn[2];
	}
	return false;
}

bool solve( int n[], char c[] )
{
	for(int m1=0; m1<512; ++m1) if( bp3(m1) && isset(n,c,m1) )
		for(int m2=0; m2<512; ++m2) if( (m1&m2)==0 && bp3(m2) && isset(n,c,m2) )
		{
			int m3 = 511 & ~m1 & ~m2;
			if( isset(n,c,m3) )
				return true;
		}
	return false;
}

int main()
{
	int T; cin >> T;
	while(T--)
	{
		int n[9];
		char c[9];
		for(int i=0; i!=9; ++i) cin >> n[i];
		for(int i=0; i!=9; ++i) cin >> c[i];
		cout << solve(n, c) << endl;
	}
	return 0;
}
