/*
MYM: Mondai Yomi Machigatteta !!!!!!!!!!!!!!!!!!!!!
*/

#include <iostream>
#include <vector>
#include <map>
using namespace std;

vector<int> GX;
map<pair<int,int>, int> memo;

int rec(int X, int K)
{
	if( 1+X <= K )
		return 0;
	else
	{
		pair<int,int> pp(X,K);
		if( memo.count(pp) )
			return memo[pp];

		int c = 0;
		if( K == 1 )
		{
			// [0..X] 1
			for(int i=0; i<X-i; ++i)
				c += GX[X-i] - GX[i];
		}
		else
		{
			c = 0x7fffffff;
			for(int x=X-1; x>=0; --x)
			{
				// [x+1..X] 1
				int c2 = 0;
				for(int i=0; x+1+i<X-i; ++i)
					c2 += GX[X-i] - GX[x+1+i];
				if( c2 >= c ) continue;
				// [...x] K-1
				int c1 = rec(x, K-1);
				c = min(c, c1 + c2);
			}
		}
		memo[pp] = c;
		return c;
	}
}

int solve(vector<int>& x, int k)
{
	GX = x;
	memo.clear();
	return rec(x.size()-1, k);
}

int main()
{
	int t; cin >> t;
	while(t--)
	{
		int n,k; cin >> n >> k;
		vector<int> x(n);
		for(int i=0; i!=n; ++i)
			cin >> x[i];
		cout << solve(x, k) << endl;
	}
	return 0;
}
