#include <iostream>
#include <vector>
#include <utility>
#include <set>
using namespace std;

int solve( vector<int> E )
{
	typedef set< pair<int,int> > SP;
	typedef SP::iterator SPI;

	SP pb;
	pb.insert( make_pair(E[0], E[1]) );
	for(int i=2; i<E.size(); i+=2)
	{
		SP pb2;
		pb2.insert( make_pair(E[i], E[i+1]) );
		for(SPI it=pb.begin(); it!=pb.end(); ++it)
		{
			if( E[i]>0 )
				pb2.insert( make_pair(E[i]-1, it->second+E[i+1]) );
			if( it->second>0 && it->first+E[i]>0 )
				pb2.insert( make_pair(it->first+E[i]-1, it->second+E[i+1]-1) );
			if( it->second>0 )
				pb2.insert( make_pair(it->first+E[i], E[i+1]) );
		}
		pb.swap(pb2);
	}

	int maxE = 0;
	for(SPI it=pb.begin(); it!=pb.end(); ++it)
		maxE = max(maxE, it->second);
	return maxE;
}

int main()
{
	int N; cin>>N;
	while(N--)
	{
		int L; cin >> L;
		vector<int> E;
		if(L%2==1) E.push_back(0);
		for(int i=0; i!=L; ++i) {
			int e; cin>>e;
			E.push_back(e);
		}
		cout << solve(E) << endl;
	}
	return 0;
}

