#include <iostream>
#include <string>
#include <queue>
#include <map>
#include <stack>
using namespace std;

int main()
{
	int t; cin>>t;
	while(t--)
	{
		static bool first = true;
		if(first) first=false; else cout<<endl;

		int G; cin >> G;
		map<char, int>  Pri;
		map<char, char> Ass;
		Pri['('] = -1;
		for(int pr=0; pr!=G; ++pr)
		{
			char A; int M;
			cin >> A >> M;
			while(M--) {
				char o;
				cin >> o;
				Pri[o] = pr;
				Ass[o] = A;
			}
		}

		int N; cin >> N;
		while(N--)
		{
			/// to RPN by shunting yard

			queue<char> Q;
			stack<char> S;

			string e; cin >> e; e = "("+e+")";
			for(int i=0; i!=e.size(); ++i)
			{
				char ch = e[i];
				if( 'a'<=ch && ch<='z' )
				{
					Q.push(ch);
				}
				else if( ch == '(' )
				{
					S.push(ch);
				}
				else if( ch == ')' )
				{
					while( S.top() != '(' )
						Q.push( S.top() ), S.pop();
					S.pop();
				}
				else
				{
					while( !S.empty() )
					{
						char o = S.top();
						if( Ass[ch]=='L' && Pri[ch]<=Pri[o]
						 || Ass[ch]=='R' && Pri[ch]< Pri[o] )
							Q.push( S.top() ), S.pop();
						else
							break;
					}
					S.push(ch);
				}
			}

			// to INFIX

			stack<string> I;
			while( !Q.empty() )
			{
				char ch = Q.front();
				Q.pop();
				if( 'a'<=ch && ch<='z' )
					I.push(string(1,ch));
				else {
					string y = I.top(); I.pop();
					string x = I.top(); I.pop();
					I.push( "("+x+ch+y+")" );
				}
			}
			cout << I.top() << endl;
		}
	}
	return 0;
}
